<?php
/*****************************************************************************/
/* Gnrateur de conf pour Solid - Rezosup				     */
/* Version initiale : MimiFleX - mimiflex@rezosup.net	juin 2005            */
/*                                                                           */
/* TODO :                                                                    */
/* - tester                                                                  */
/* - re-tester                                                               */
/* - re-re-tester                                                            */
/* - finir la gestion des blocs imbriqus                                    */
/* - possibilit de rajouter des conditions :                                */
/*   ex: - ne demander les leafs que si le serveur est un hub                */
/*       - ne demander les certificats et cls SSL que si au moins 1 port est*/
/*	   SSL                          				     */
/*****************************************************************************/

/*****************************************************************************/
/*Configuration                                                              */
/*****************************************************************************/

// Version
define(VERSION,"0.2b");

// Path du fichier template
define(TEMPLATE_FILE,"ircd.conf.tpl");

//Nom du fichier gnr
define(OUT_FILE,"ircd.conf");






/*****************************************************************************/
/* Fin de la onfiguration                                                    */
/*****************************************************************************/


function read_tpl() {
	// lit le template
	$content = file_get_contents(TEMPLATE_FILE) or die("Impossible de lire le fichier ".TEMPLATE_FILE);
	return $content;	
}

function parse_tpl($tpl) {
	// parse le template (retourn par read_tpl())
	// retourne un tableau contenant les tokens;
	preg_match_all ( "/%[^%]+%/",$tpl,$resultats );
	$result = array();
	reset($resultats[0]);
	while(list(,$item)=each($resultats[0])) {
		if (!in_array($item,$result)||$item=="%KCOLB%") $result[]=$item;
	}
	return $result;
}

function recursion_data($tokens,$offset=0) {
	global $indexes;
	$data = array(
			"singles"=>array(), // les simples valeurs
			"blocks"=>array() // les blocs tel que hubs, ports, o-lines...
		);
		

	$depth=0; //profondeur d'tude dans un bloc
	for ($i=$offset;$i<count($tokens);$i++) {
		
		$token = $tokens[$i];
		// rcupration du type entre : VAR ASK et BLOCK/KCOLB
		ereg("^%([A-Z]+)[%:].*$",$token,$resultat) or die ("erreur : $token type non reconnu");
		
		
		
		switch($resultat[1]) {
			case "VAR":
				//echo "\t- Traitement de VAR\n";
				// c'est une variable
				ereg("^%VAR:([^:]+):(text|password):(\\^[^$]+\\$):([^:]+):([^:%]*)%$",$token,$r) or die ("erreur de syntaxe pour $token");
				//print_r($r);
				// si on est l c'est que le token  l'air complet, on stocke les infos
				$data["singles"][]=array(
					"type"    => "VAR", //type : VAR, ASK ...
					"token"   => $r[0], //le token en entier (%...%) mmoris pour le le ereg_replace final
					"nom"     => $r[1], //le nom de la variable
					"htype"   => $r[2], //le type html pour la gnration du formulaire
					"regex"   => $r[3], //la regex qui servira a vrifier la validit de la valeur saisie
					"desc"    => $r[4], //la description qui sera donne dans le formulaire html
					"exemple" => $r[5]  //exemple qui sera donn dans le formulaire html
				);
				break;
				
			case "ASK":
				//echo "\t- Traitement de ASK\n";
				// c'est une question
				ereg("^%ASK:([^:]+):([^:]+):([^:]*):([^:%]*)%$",$token,$r) or die ("erreur de syntaxe pour $token");
				//print_r($r);
				// si on est l c'est que le token  l'air complet, on stocke les infos
				$data["singles"][]=array(
					"type"    => "ASK",     //type : VAR, ASK ...
					"token"   => $r[0],     //le token en entier (%...%) mmoris pour le le ereg_replace final
					"nom"     => $r[1],     //le nom de la variable
					"desc"    => $r[2],     //la description qui sera donne dans le formulaire html
					"val_oui" => $r[3],	//valeur si oui
					"val_non" => $r[4]	//valeur si non
				);
				break;
				
			case "SELECT":
				// c'est un select
				ereg("^%SELECT:([^:]+):([^:]+):([^%]*)%$",$token,$r) or die ("erreur de syntaxe pour $token");
				//print_r($r);
				// si on est l c'est que le token  l'air complet, on stocke les infos
				//remplissage de val_select
				preg_match_all('/([^:=]+)=([^:]*)/',$r[3],$matches,PREG_SET_ORDER);
				reset($matches);
				$val_select=array();
				while (list(,$val)=each($matches)) {
					$val_select[$val[1]]=$val[2];
				}
				$data["singles"][]=array(
					"type"    => "SELECT",     //type : VAR, ASK ...
					"token"   => $r[0],     //le token en entier (%...%) mmoris pour le le ereg_replace final
					"nom"     => $r[1],     //le nom de la variable
					"desc"    => $r[2],     //la description qui sera donne dans le formulaire html
					"val_select" => $val_select	//couples desc/valeurs du select
				);
			
				break;

			case "BLOCK":
				//echo "\t- Traitement du BLOCK\n";
				$depth++;
				ereg("^%BLOCK:([0-9]+):([^:%]+)%$",$token,$r) or die ("erreur de syntaxe pour $token");
				//print_r($r);
				list($sub_data,$i) = recursion_data($tokens,$i+1); //hop la rcursivit ;)
				$data["blocks"][]=array(
					"token"   => $r[0],     //le token en entier (%...%) mmoris pour le le ereg_replace final
					"nombre"  => $r[1],	//nombre de blocs de ce type par dfaut
					"desc"    => $r[2],     //la description qui sera donne dans le formulaire html
					"data"	  => $sub_data	//les donnes rcupres dans le bloc
				);
				break;

			case "KCOLB":
				//echo "\t- Fermeture du BLOCK\n";
				$depth--;
				// rien que pour faire chier le templateur, on vrifie la syntaxe du token :-D
				ereg("^%KCOLB%$",$token) or die ("erreur de syntaxe pour $token");
				$resultat = array($data,$i); // on renvoie l'offset courant au flux parent
				return $resultat; //on retourne les infos au niveau suprieur
				break;        //au cas o ?!
			case "INDEX":
				ereg("^%INDEX:([^:%]+)%$",$token,$r) or die ("erreur de syntaxe pour $token");
				//print_r($r);
				// si on est l c'est que le token  l'air complet, on stocke les infos
				$indexes[]=array(
					"type"    => "INDEX", //type : VAR, ASK ...
					"token"   => $r[0], //le token en entier (%...%) mmoris pour le le ereg_replace final
					"nom"     => $r[1], //le nom de la variable
				);
				break;
				

			default:
				die ("$token <- c'est quoi cette merde ? :)");
		
		} // fin du switch
		
		//print_r($data);
	} // fin du for
	if (!$depth) die ("Problme de blocs !\n"); // si depth n'est pas  0 apres tout ce bordel, c'est qu'il y a une couille d'ouverture/fermeture	
	$resultat = array($data,$i); // on renvoie l'offset courant au flux parent
	return $resultat;
}

function gen_data($tokens) {
	list($data,)=recursion_data($tokens);
	return $data;

}




function gen_field($item,$nom,$values,$couleur="#FFFFFF") {
	global $error_desc;
	# gnre le champs en HTML concernant l'item $item.
	# le champs gnr prend le nom $nom..
	if ($item["type"]=="ASK") {
		$type="radio";
	} else if ($item["type"]=="SELECT") {
		$type="select";
	} else {
		$type=$item["htype"];
	}
	$desc = $item["desc"];
	$regex = $item["regex"];
	$example = $item["exemple"];
	$val_oui = $item["val_oui"];
	$val_non = $item["val_non"];
	$val_select = $item["val_select"];
	$resultat = "";
	$erreur = $error_desc[$nom];
	if ($erreur) $couleur="#FF8080";

	$obligatoire=!@ereg($regex,"");

	if ($obligatoire) $desc="<b>$desc</b>";
	
	$value = $values[$nom];
	
	switch($type) {
		case "text":
		case "password":
			$resultat = "<tr bgcolor='$couleur'>\n<td align='left'>$desc<br /><font size='-1'>ex: $example</font></td><td align='left'><input type='$type' name='$nom' value=\"$value\" size='45' /></td></tr>\n";
		break;
		
		case "radio":
			$resultat = "<tr bgcolor='$couleur'>\n<td align='right'>$desc</td><td align='left'>Oui<input type='$type' name='$nom'".($value==$val_oui?" checked":"")." value=\"$val_oui\" />&nbsp;Non<input type='$type' name='$nom'".(($value==$val_non||!$value)?" checked":"")." value=\"$val_non\" /></td></tr>\n";
		break;

		case "select":
			$resultat = "<tr bgcolor='$couleur'>\n<td align='left'>$desc</td><td align='left'><select name='$nom'>\n";
			reset($val_select);
			while(list($desc,$val)=each($val_select)) {
				$resultat .= "<option value=\"$val\" ".($value==$val?"selected ":"").">$desc</option>\n";
			}
			$resultat.= "</select></td></tr>\n";
		break;

		default: die("Type '$type' inconnu pour l'lment $token !\n");
	}

	return $resultat;
}

class Couleur {
	var $index=0;
	var $liste;
	function Couleur($liste_couleurs=array("#d1dcff","#e0e8ff")) {
		$this->liste=$liste_couleurs;
	}
	function get() {
		$this->index=(($this->index)+1)%(count($this->liste));
		return ($this->liste[$this->index]);
	}
}

function gen_form($data,$values=array()) {
	#gnre un formulaire
	$couleur = new Couleur();
	$resultat = "";
	$resultat.="<form action='".$_SERVER["PHP_SELF"]."' method='POST'>\n";
	$resultat.="<input type='hidden' value='0' name='refresh' />\n";
	$resultat.="<table cellspacing='0' cellpadding='4'>\n";
	$resultat.=recursion_form($data,$values);
	$resultat.="<tr><td colspan='2' bgcolor='".$couleur->get()."' align='center'><input type='submit' name='display' value='Afficher la conf' /><input type='submit' name='download' value='Tlcharger la conf' /></td></tr>";
	$resultat.="</table>\n";
	$resultat.="</form>\n";
	return $resultat;
}

function number_field($nom,$value,$min,$max) {
	$resultat="";
	$resultat.="<select name='$nom' OnChange='refresh.value=1; submit();' >\n";
	for ($i=$min;$i<=$max;$i++) {
		$resultat.="<option value='$i' ".(($i==$value)?"selected":"")." />$i\n";
	}
	$resultat.="</select>\n";
	return $resultat;	
}


function recursion_form($data,$values,$val_prefix="") {
	// data contient un array singles et un array blocks
	$singles = $data["singles"];
	$blocks  = $data["blocks"];

	reset($singles);
	reset($blocks);

	$couleur = new Couleur();
	$resultat = "";
	
	// on commence par le plus simple,  savoir la gnration des champs pour les singles
	while(list($key,$item)=each($singles)) {
		switch ($item["type"]) {
			case "VAR":
				$keypfx="v";
				break;
			case "ASK":
				$keypfx="a";
				break;
			case "SELECT":
				$keypfx="s";
				break;
			default:
				die("Ah bah bravo, vous avez trouv un bug, c'est malin !");

		}
		$nom = $val_prefix."s${keypfx}${key}";
		$resultat.=gen_field($item,$nom,$values,$couleur->get());
	}

	// on s'attaque ensuite aux blocs
	while(list($key,$item)=each($blocks)) {
		$prefix = $val_prefix."b$key-";
		$coul = $couleur->get();
		$nombre = (($values[$prefix."nombre"])?$values[$prefix."nombre"]:$item["nombre"]);
		
		$resultat.="<tr bgcolor='$coul'>\n";
		$resultat.="<td	align='left'>\n";	
		$resultat.="<b>".$item["desc"]."</b><br />\n";
		$resultat.="Nombre : ".number_field($prefix."nombre",$nombre,0,10);
		$resultat.="</td>\n<td align='left'>\n";
		for ($i=0; $i<$nombre ; $i++) {
			$resultat.="<table cellspacing='0' cellpadding='4' width='100%' border='0'>\n";
			$resultat.=recursion_form($item["data"],$values,$prefix."i$i-");
			$resultat.="</table>\n";
			if ($i<$nombre-1) $resultat.="<hr />\n";
		}
		$resultat.="</td>\n</tr>\n";
	}

	return $resultat;
}


function decode_nom($nom) {
	// dcode le nom d'un champ du formulaire et renvoie qq infos :)
	if (ereg("^(b[0-9]+-i[0-9]+-)?((b[0-9]+-i[0-9]+-)*s([avs])([0-9]+))$",$nom,$reg)) {
		switch($reg[4]) {
			case "a" : $type="ASK";
				   break;
			case "s" : $type="SELECT";
				   break;
			case "v" : $type="VAR";
				   break;
			default : die("Type inconnu dans decode_nom\n");
		}
		$res = array(
			"type"=>$type,
			"num"=>$reg[5],
			"prefix"=>$reg[1],
			"suffixe"=>$reg[2]
		);
		if ($reg[1]) {
			ereg("^b([0-9]+)-i([0-9]+)-$",$reg[1],$reg2);
			$res["bnum"]=$reg2[1];
			$res["inum"]=$reg2[2];
		}
	} else {
		$res = false;
	}
//	print_r($res);
	return $res;
}


function merge($values,$post) {
/*
	reset($post);
	while(list($key,$val)=each($post)) {
		$values[$key]=$val;
	}
	reset($values);
	while(list($key,$val)=each($values)) {
		$r=decode_nom($key);
		if (($r["type"]=="ASK")&&(!$post[$key])&&($post[$r["block"]."-nombre"]>($r["num"]+1))) $values[$key]="";
		//echo "********** Nombre de blocks ".$r["block"]." : ".$post[$r["block"]."-nombre"]."\n" ;
	}
*/
	$values = array_merge($values,$post);
	return $values;
}


function recursion_traiter_post($post,$data,$prefix="",$offset=0) {
	global $error_found;
	global $error_desc;
	
	//lit toutes les infos venant du post et gnre les instructions
	//de gnration du fichier de conf
	$resultat = array();
	reset ($post);
	
	$pos = 0;
	
	#on se dplace de offset dans le tableau $post
	for ($i=0;$i<$offset;$i++) {
		each($post);
		$pos++;
	}
	
	#on continue
	while (list($key,$val)=each($post)) {
		//echo "$key : $val\n";
		/* pour chaque item :
			- on retrouve  quel token on fait allusion
			- on stocke un couple token/valeur substitue dans $resultat
		*/
		$pos++;
		$infos = decode_nom($key);
		if ($infos) {
			//print_r($infos);	
			// les infos ont pu tre dcodes
			if (!$infos["prefix"]) {
				// la c'est le cas simple, ce n'est pas un bloc
				$tok = $data["singles"][$infos["num"]];
				$regex = $tok["regex"];
				if ($regex) $erreur = (!(@ereg($regex,$val))?1:0);
				$resultat["singles"][$infos["num"]] = array(
					"token" => $tok,
					"name"  => $key,
					"erreur"=> $erreur,
					"valeur"=> $val
				);
			} else {
				// c'est un bloc
				// on est cens grer la recursivit, mais pour une question de temps
				// on zappe et on suppose que des blocs ne peuvent pas tres imbriqus dans
				// une conf de solid, ce qui est le cas
				$tok = $data["blocks"][$infos["bnum"]]["data"]["singles"][$infos["num"]];
				$regex = $tok["regex"];
				if ($regex) $erreur = (!(@ereg($regex,$val))?1:0);
				$resultat["blocks"][$infos["bnum"]][$infos["inum"]][$infos["num"]] = array(
					"token" => $tok,
					"name"  => $key,
					"erreur"=> $erreur,
					"valeur"=> $val
				);
			}
			$error_found = $error_found || $erreur;
			if ($erreur&&$regex) $error_desc[$key]= "Erreur sur ".$tok["desc"];
		}
	} //fin du while


	return (array($resultat,$pos));
}


function traiter_post($post,$data) {
	list($resultat,)=recursion_traiter_post($post,$data);
	return $resultat;
}


function generer($valeurs) {
	//print_r($valeurs);
	//genere le fichier  partir du rsultat de la
	//fonction traiter_post

	global $indexes;
	$fh = fopen(TEMPLATE_FILE,'r');
	$template = array();
	$profondeur = 0;
	$block = 0;
	while (list($key,) = each($indexes)) {
		$indexes[$key]["valeur"]=0;
	}
	//print_r($indexes);
	while ($ligne = fgets($fh)) {
		if(ereg("%BLOCK:([0-9]+):([^:%]+)%",$ligne)) {
			// c'est un debut de block
			$profondeur++;
			$temp = array();
		} else if (ereg("%KCOLB%",$ligne)) {
			// c'est la fin d'un block
			$nombre = count($valeurs["blocks"][$block]);
			for ($i=0;$i<$nombre;$i++) {
				reset($temp);
				while (list(,$ligne) = each($temp)) {
					reset($indexes);
					while(list($key,$val)=each($indexes)) {
						$ligne = str_replace($val["token"],$i,$ligne);
					}
					$template[] = substituer($ligne,$valeurs,$block,$i);
				}
			}

	
			$profondeur--;
			$block++;
		} else {
			if ($profondeur) {
				// on est dans un block
				$temp[] = $ligne;
			} else {
				$template[] = substituer($ligne,$valeurs);
			}

		}
	
	}
	return $template;

}

function substituer($ligne,$post_ok,$block=-1,$instance=-1) {
	global $indexes;
	if ($block<0) {
		while(list(,$val)=each($post_ok["singles"])) {
			//echo "on tente de substituer ".$val["valeur"]."  ".$val["token"]["token"]." dans $ligne";
			$ligne = str_replace($val["token"]["token"],$val["valeur"],$ligne);
			//echo "--->$ligne";
		}

	} else {
		while(list(,$val)=each($post_ok["blocks"][$block][$instance])) {
			$ligne = str_replace($val["token"]["token"],$val["valeur"],$ligne);
		}

	}
	while (list($key,$val)=each($indexes)) {
		$ligne = str_replace($val["token"],$val["valeur"],$ligne);
	}
	return $ligne;
}



///////////////////////////////////////////////////////////////////////////////////////////



#session_start();

$tpl=read_tpl();
$tokens=parse_tpl($tpl);
$data = gen_data($tokens);

if ($_POST["display"]||$_POST["download"]) {
	$values=array_map(stripslashes,$_POST);
	$_SESSION["VALUES"] = $values;

	$post_ok = traiter_post($values, $data);
	if (!$error_found) {
		header("Content-type: text/plain");
		if ($_POST["download"]) header('Content-Disposition: attachment; filename="'.OUT_FILE.'"');
		$conf = generer($post_ok);
		echo "# configuration gnre le ".date('r')."\n# par ".$_SERVER["HTTP_REFERER"]." version ".VERSION."\n";
		reset($conf);
		while(list(,$ligne)=each($conf)) echo $ligne;
	}
		//print_r($post_ok);
} 

if (!($_POST["display"]||$_POST["download"])||$error_found) {
	// on rcupre les infos venant du formulaire et de la session
//	$values=array_merge($_SESSION["VALUES"],array_map(stripslashes,$_POST));

	$values=merge($_SESSION["VALUES"],array_map(stripslashes,$_POST));
	$_SESSION["VALUES"] = $values;


	?>
	<html>
	<head />
	<body>
	<div align='center'><h1>Gnrateur de configuration SolidIRCd<br />RezoSup</h1>
	<?php
	/*
	if ($error_found) {
		echo "Des erreurs ont t trouves dans les informations saisies.\n";
		echo "<ul>\n";
		reset($error_desc);
		while(list($key,$desc)=each($error_desc)) echo "<li />$key : $desc\n";
		echo "</ul>";
	}
	*/
	echo "Les champs en <b>gras</b> sont obligatoires<br />\n";
	echo gen_form($data,$values);
	/*
	if ($error_found) {
		echo "<pre>";
		print_r($post_ok);
		echo "</pre>";
	};
	*/
	?>
	</div>
	</body>
	</html>
	<?php
	

}

