# =========================================================================
#  
#
#      ____                _____
#     / __ \___ ____ ____ / ___/__  ______
#    / /_/ / _ Y_  // __ \\__ \/ / / / __ \
#   / _, _/  __// // /_/ /__/ / /_/ / /_/ /
#  /_/ |_|\___//___|____/____/\__,_/ .___/
#                                 /_/
#
# http://www.rezosup.org/
# =========================================================================
# Template version - 1118872655

/* server name and administration info */
global {
    name    irc.%VAR:ECOLE:text:^[^\"\ ]+$:Nom de l'cole:ecole%.rezosup.org;     # IRC name of the server
    info    "%VAR:SERVER_INFO:text:^[^\"]+$:Description du serveur:Serveur IRC de chez bidule (ville)%";     # A short info line
    admin {
        "%VAR:ADMIN_REPLY1:text:^[^\"]+$:Rponse  /ADMIN ligne 1:Vos administrateurs sont toto, titi, tata%";   # Three information lines sent
        "%VAR:ADMIN_REPLY2:text:^[^\"]*$:Rponse  /ADMIN ligne 2:toto@domaine.net, titi@domaine.net, tata@domaine.net%";   # in reply to ADMIN command
        "%VAR:ADMIN_REPLY3:text:^[^\"]*$:Rponse  /ADMIN ligne 3:Bla bla bla%";
    };
    dpass   %VAR:DPASS:password:^[^\"\ ]{8,}$:Password du /DIE<br /><font size=-1>(8 caractres minimum)</font>:totototo%;                 # Password for DIE command
    rpass   %VAR:RPASS:password:^[^\"\ ]{8,}$:Password du /RESTART<br /><font size=-1>(8 caractres minimum)</font>:tatatata%;                 # Password for RESTART command
};

# =========================================================================
/* server options */
options {
    servtype	%ASK:SERVTYPE:Ce serveur est-il un hub ?:hub:client%;
    local_kline     %VAR:KLINE_MAIL:text:^[^@\ ]+@[^@\ ]+$:Mail de contact concernant les KLINES locales:toto@domaine.net%;   # Contact email for server bans
    show_links;                     # Show servers in LINKS

    /* Oper Hostmasking */
    staff_address     "staff.%VAR:ECOLE:text:^[^\"\ ]+$:Nom de l'cole:ecole%.rezosup.net";
    
    /* Set the following modes on connect? */
    auto_umode_v;

    /* on chiffre les pass opers */
    crypt_oper_pass;

    wgmonhost       "services.rezosup.net";          # Wingate monitor scan host
    wgmonurl        "http://www.rezosup.org/proxy.phtml";     # URL for wingatemonitor info
};


# =========================================================================
/* where to listen for connections */
%BLOCK:2:Ports d'coute du serveur%
port {
    port    %VAR:LISTEN_PORT:text:^[1-9][0-9]*$:Port:6667 ou 6767 en SSL%;         # Port to listen on
    bind    %VAR:BIND_PORT:text:^([0-9]+.[0-9]+.[0-9]+.[0-9]+|\*)$:IP Bind:123.123.123.123 ou *%;    # IP address to listen on
    %ASK:SSL:Port SSL ?:type ssl;:%
};


%KCOLB%


# =========================================================================
%BLOCK:1:Nombre de classes utilisateurs%
/* allow clients to connect */
allow {
    host    %VAR:USERHOST:text:^[^\"\ \@]+$:Hte:*, 123.124.125.126%;
    class   users%INDEX:USERCLASS%;  # Place them in the users class
};

/* connection class for users */
class {
    name        users%INDEX:USERCLASS%;      # Class name
    maxusers    %VAR:MAXUSERS:text:^[1-9][0-9]*$:Nombre maximum d'utilisateurs:200%;        # Maximum connections
    pingfreq    90;         # Check idle connections every N seconds
    maxsendq    500000;     # 500KB send buffer limit
};


%KCOLB%

# =========================================================================
/* connection class for server operators */
class {
    name        opers;
    pingfreq    90;
    maxsendq    1000000;     # 1,00MB limit for opers
};

/* Secure Socket Layer (SSL) */
ssl {
    certificate "%VAR:SSL_CERTIFICATE_PEM:text:^[^\"]+$:Localisation du certificat SSL:ssl/rz.pem%";    # Server Certificate
    keyfile  "%VAR:SSL_KEY_PEMS:text:^[^\"]+$:Localisation des clefs SSL:ssl/rzkey.pem%";    # Keys for the server
    allow_umodez;                 # Allow SSL users to change UMODE_z
};


# =========================================================================
%BLOCK:1:Opers%
/* the server administrator */
oper {
    name    %VAR:OPERNAME:text:^[^\"\ ]+$:Nom de l'oper:Frantico%;                # Username
    passwd  %VAR:OPERPASS:text:^[^\"\ ]+$:Mot de passe <b>chiffr</b><br /><font size=-1>(utiliser mkpasswd de Solid)</font>:evilpassword%;         # Password
    access  %SELECT:OPERMODE:Statut:Oper=OF:Admin serveur=OFaA:Admin services=OFa%%ASK:OPERDIE:Droit de /DIE ?:D:%%ASK:OPERRESTART:Droit de /RESTART ?:R:%;
    host    %VAR:OPERHOST:text:^([^\"@\ ]+@[^\"\*\ ]+|[^\"@\ ]+)$:Hte:toto@somewhere%;       # Must be connecting from here
    class   opers;                # Belongs in the opers class
};


%KCOLB%

# =========================================================================
/* for services */
super {
    "services.rezosup.net";
    // insert any other special servers here
};

# =========================================================================
/* reserved nicknames */
restrict { type nick; mask "NickServ"; reason "reserved for services"; };
restrict { type nick; mask "ChanServ"; reason "reserved for services"; };
restrict { type nick; mask "MemoServ"; reason "reserved for services"; };
restrict { type nick; mask "RootServ"; reason "reserved for services"; };
restrict { type nick; mask "OperServ"; reason "reserved for services"; };
restrict { type nick; mask "StatServ"; reason "reserved for services"; };
restrict { type nick; mask "HelpServ"; reason "reserved for services"; };
restrict { type nick; mask "services"; reason "reserved for services"; };


# =========================================================================

%BLOCK:1:Hubs d'accs au rseau%
/* === these next two blocks are for linking to a hub === */

/* class for auto-connect uplink hub */
class {
    name        hubuplink%INDEX:HUBCLASS%;
    pingfreq    120;        # Idle check every 2 minutes
    connfreq    180;         # Try autoconnect every 3 minutes
    maxsendq    1000000;    # 1MB send queue
    maxlinks    1;          # Autoconnect to only 1 hub at a time
};

/* class for uplink hub */
class {
    name        hub%INDEX:HUBCLASS%;
    pingfreq    120;        # Idle check every 2 minutes
    maxsendq    1000000;    # 1MB send queue
    maxlinks    1;          # Autoconnect to only 1 hub at a time
};

/* our uplink hub */
connect {
    name        %VAR:HUB_NAME:text:^[^\"\ ]+$:Nom du HUB:hub.youpi.net%;        # Hub's IRC name
    host        %VAR:HUB_IP:text:^([0-9]+.[0-9]+.[0-9]+.[0-9]+|\*)$:Adresse IP du HUB:123.123.123.123%;          # Hub's IP address
    port        %VAR:HUB_PORT:text:^[1-9][0-9]*$:Port du HUB:50000%;       # Autoconnect to hub's port 7325
    bind        %VAR:BIND_IP_HUB:text:^([0-9]+.[0-9]+.[0-9]+.[0-9]+|\*)$:Adresse de bind:123.123.123.123%;     # We connect from this IP
    apasswd     %VAR:APASSWORD_HUB:password:^[^\"\ ]+$:A password:toto%;    # We accept this password from hub
    cpasswd     %VAR:CPASSWORD_HUB:password:^[^\"\ ]+$:C password:titi%;   # We send this password to hub
    class 	%ASK:CLASS:Connexion automatique ?:hubuplink:hub%%INDEX:HUBCLASS%;         # Use hub class
    flags       ZEH;   
};


%KCOLB%

# =========================================================================
class {
    name        leaf;
    pingfreq    120;        # Idle check every 2 minutes
    connfreq    180;        # Try autoconnect every 5 minutes
    maxsendq    1000000;    # 1MB send queue
};


%BLOCK:0:Leafs<br />(si ce serveur est un hub uniquement)%
/* leaf */
connect {
    name        %VAR:LEAF_NAME:text:^[^\"\ ]+$:Nom du Leaf:irc.youpi.org%;        # Hub's IRC name
    host        %VAR:LEAF_IP:text:^([0-9]+.[0-9]+.[0-9]+.[0-9]+|\*)$:Adresse IP du Leaf:123.123.123.123%;          # Hub's IP address
    bind        %VAR:BIND_IP_LEAF:text:^([0-9]+.[0-9]+.[0-9]+.[0-9]+|\*)$:Adresse de bind:123.123.123.123%;     # We connect from this IP
    apasswd     %VAR:APASSWORD_LEAF:password:^[^\"\ ]+$:A password:toto%;   # We accept this password from leaf
    cpasswd     %VAR:CPASSWORD_LEAF:password:^[^\"\ ]+$:C password:titi%;   # We send this password to leaf
    flags       ZE;  
    class 	leaf;
};


%KCOLB%


